/*

*/
#property copyright "Son_Of_Earth"
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DarkTurquoise  
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Coral
#property indicator_color5 Coral
#property indicator_color6 YellowGreen
#property indicator_color7 MediumTurquoise
#property indicator_color8 MediumTurquoise
#property indicator_width1 2

extern string    Symbol1.Name="FDAXH1#I"; //  BUY#I.   ,     .
extern string    Symbol2.Name="FESXH1#I"; //  SELL#I.
extern double    Symbol1.Vol=1;           //   BUY
extern double    Symbol2.Vol=1;           //   SELL
extern bool      BidAsk.Show = true;      //   -
extern bool      Env.Show = true;         //  
extern bool      EquityScale = true;      //   
extern int       Env.Period = 34;        //   
extern double    Env.Dev = 1.0;           //    
extern double    Alert.BidMore = EMPTY;   //  ,    
extern double    Alert.AskLess = EMPTY;   //  ,    

double Last[];
double _Ask[];
double _Bid[];
double EnvUp2[], EnvUp1[], MA[], EnvDn1[], EnvDn2[];
int wndNum;                                //   
string wndName;                            //  
int soundCount; 
double Symbol1.K, Symbol2.K;
string sname;

string oComment="spreadParam";             //   

//===============================================================

int init(){

  if(Symbol1.Name=="") Symbol1.Name=Symbol();
  Symbol1.Name=StringUpper(Symbol1.Name);
  Symbol2.Name=StringUpper(Symbol2.Name);
  
  if(EquityScale) {
    Symbol1.K = MarketInfo(Symbol1.Name, MODE_TICKVALUE)/MarketInfo(Symbol1.Name, MODE_TICKSIZE);
    Symbol2.K = MarketInfo(Symbol2.Name, MODE_TICKVALUE)/MarketInfo(Symbol2.Name, MODE_TICKSIZE);
  }
  else {
    Symbol1.K = 1;
    Symbol2.K = 1;
  }
 
  int StartBar = Bars - MathMax(iBarShift(NULL,0,MathMax(iTime(Symbol1.Name,0,iBars(Symbol1.Name,0)-1),iTime(Symbol2.Name,0,iBars(Symbol2.Name,0)-1))),0);

  sname = DoubleToStr(Symbol1.Vol,2)+"*"+DoubleToStr(Symbol1.K,0)+"*"+Symbol1.Name;
  sname=sname+"-";
  sname=sname+DoubleToStr(MathAbs(Symbol2.Vol),2)+"*"+DoubleToStr(Symbol2.K,0)+"*"+Symbol2.Name;
  if(Env.Show)
    sname=sname+"("+Env.Period+","+DoubleToStr(Env.Dev,2)+")";

  SetIndexShift(0,0);
  SetIndexBuffer(0,Last);
  SetIndexStyle(0,DRAW_LINE);
  SetIndexLabel(0,"Last");
  SetIndexDrawBegin(0,StartBar);

  if(BidAsk.Show) {
    SetIndexShift(1,0);
    SetIndexBuffer(1,_Ask);
    SetIndexStyle(1,DRAW_LINE);
    SetIndexLabel(1,"Ask");
    SetIndexDrawBegin(1,StartBar);

    SetIndexShift(2,0);
    SetIndexBuffer(2,_Bid);
    SetIndexStyle(2,DRAW_LINE);
    SetIndexLabel(2,"Bid");
    SetIndexDrawBegin(2,StartBar);
  }

  if(Env.Show) {
    SetIndexShift(3,0);
    SetIndexBuffer(3,EnvUp2);
    SetIndexStyle(3,DRAW_LINE);
    SetIndexLabel(3,"EnvUp2");
    SetIndexDrawBegin(3,StartBar+Env.Period);

    SetIndexShift(4,0);
    SetIndexBuffer(4,EnvUp1);
    SetIndexStyle(4,DRAW_LINE);
    SetIndexLabel(4,"EnvUp1");
    SetIndexDrawBegin(4,StartBar+Env.Period);

    SetIndexShift(5,0);
    SetIndexBuffer(5,MA);
    SetIndexStyle(5,DRAW_LINE);
    SetIndexLabel(5,"MA");
    SetIndexDrawBegin(5,StartBar+Env.Period);

    SetIndexShift(6,0);
    SetIndexBuffer(6,EnvDn1);
    SetIndexStyle(6,DRAW_LINE);
    SetIndexLabel(6,"EnvDn1");
    SetIndexDrawBegin(6,StartBar+Env.Period);

    SetIndexShift(7,0);
    SetIndexBuffer(7,EnvDn2);
    SetIndexStyle(7,DRAW_LINE);
    SetIndexLabel(7,"EnvDn2");
    SetIndexDrawBegin(7,StartBar+Env.Period);
  }

  soundCount=10;

  return(0);
}

//===============================================================

int deinit()  {
  //    
  DeleteObject(oComment);
  return(0);  
}

//===============================================================

int start()
{
  wndNum=WindowFind(WindowExpertName());
  wndName=WindowExpertName()+wndNum; 
  DrawLabel(oComment, sname, 8, DarkGray, 16);
  int    counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--; 
  int limit=Bars-counted_bars;

  int i;
  datetime t;

  if(BidAsk.Show) {
    double ask1 = Symbol1.Vol*Symbol1.K*MarketInfo(Symbol1.Name,MODE_ASK);
    double bid1 = Symbol1.Vol*Symbol1.K*MarketInfo(Symbol1.Name,MODE_BID);
    double ask2 = Symbol2.Vol*Symbol2.K*MarketInfo(Symbol2.Name,MODE_ASK);
    double bid2 = Symbol2.Vol*Symbol2.K*MarketInfo(Symbol2.Name,MODE_BID);
    double _ask = ask1-bid2, 
           _bid = bid1-ask2;
  }

  for (i=0;i<limit;i++) {
    t=Time[i];
    Last[i] = Symbol1.Vol*Symbol1.K*iClose(Symbol1.Name,0,iBarShift(Symbol1.Name,0,t)) - 
              Symbol2.Vol*Symbol2.K*iClose(Symbol2.Name,0,iBarShift(Symbol2.Name,0,t));
    if(BidAsk.Show) {
      _Ask[i]=_ask;
      _Bid[i]=_bid;
    }
  }

  if(Env.Show) {
    for(i=0;i<limit;i++) {
      EnvUp2[i]=iEnvelopesOnArray(Last,0,Env.Period,MODE_SMA,0,Env.Dev,MODE_UPPER,i);
      EnvUp1[i]=iEnvelopesOnArray(Last,0,Env.Period,MODE_SMA,0,Env.Dev/2,MODE_UPPER,i);
      MA[i]=iMAOnArray(Last,0,Env.Period,0,MODE_SMA,i);
      EnvDn1[i]=iEnvelopesOnArray(Last,0,Env.Period,MODE_SMA,0,Env.Dev/2,MODE_LOWER,i);
      EnvDn2[i]=iEnvelopesOnArray(Last,0,Env.Period,MODE_SMA,0,Env.Dev,MODE_LOWER,i);
    }
  }
  if (soundCount>0 && 
      ((Alert.BidMore!=EMPTY &&  _Bid[0]>Alert.BidMore) || (Alert.AskLess!=EMPTY && _Ask[0]<Alert.AskLess))) {
    PlaySound("alert2.wav");
    Print(Symbol1.Name+"-"+Symbol2.Name+": channel width condition is achived"); 
    soundCount--;
  }
}

//-----------------------------------------

//  
void DrawLabel(string aName, string aText, int aFontSize, color aColor, int aValue) {
  string objName=aName+wndName;
//  ObjectDelete(objName);
  ObjectCreate(objName, OBJ_LABEL, wndNum, 0, 0);
  ObjectSetText(objName, aText, aFontSize, "Verdana", aColor);
  ObjectSet(objName, OBJPROP_CORNER, 0);
  ObjectSet(objName, OBJPROP_XDISTANCE, 4);
  ObjectSet(objName, OBJPROP_YDISTANCE, aValue); 
}

//   
void DeleteObject(string name) {
  ObjectDelete(name+wndName);
}

string StringUpper(string s) {
  int c, i, k=StringLen(s), n;
  for (i=0; i<k; i++) {
    n=0;
    c=StringGetChar(s, i);
    if (c>96 && c<123) n=c-32;    // a-z -> A-Z
    if (c>223 && c<256) n=c-32;   // - -> -
    if (c==184) n=168;            //    ->  
    if (n>0) s=StringSetChar(s, i, n);
  }
  return(s);
}

